import { ArrayAST, LiteralAST, ReferencesAST, StringAST } from '../type';
import { Compile } from './compile';
/**
 * literal parse, include string, integer, array, map, bool data structure
 * @require {method} getReferences
 */
export declare class LiteralCompiler extends Compile {
    /**
     * 字面量求值，主要包括string, integer, array, map四种数据结构
     * @param literal {object} 定义于velocity.yy文件，type描述数据类型，value属性
     * 是literal值描述
     * @return js variable
     */
    getLiteral(literal: LiteralAST | ReferencesAST): any;
    /**
     * 对字符串求值，对已双引号字符串，需要做变量替换
     */
    getString(literal: StringAST): string;
    /**
     * 对array字面量求值，比如[1, 2]=> [1,2]，[1..5] => [1,2,3,4,5]
     * @param literal {object} array字面量的描述对象，分为普通数组和range数组两种
     * ，和js基本一致
     * @return {array} 求值得到的数组
     */
    getArray(literal: ArrayAST): unknown[];
}
