import { Compile } from './compile';
import { Attribute, IndexAttribute, Method, ReferencesAST } from '../type';
export declare class References extends Compile {
    /**
     * get variable value
     * @param {object} ast ast data
     * @param {bool} isVal for example `$foo`, isVal value should be true, other condition,
     * `#set($foo = $bar)`, the $bar value get, isVal set to false
     */
    getReferences(ast: ReferencesAST, isVal?: boolean): any;
    /**
     * 获取局部变量，在macro和foreach循环中使用
     */
    getLocal(ast: ReferencesAST): {
        value: boolean;
        isLocal: boolean;
    };
    /**
     * $foo.bar 属性求值，最后面两个参数在用户传递的函数中用到
     * @param {object} property 属性描述，一个对象，主要包括id，type等定义
     * @param {object} baseRef 当前执行链结果，比如$a.b.c，第一次baseRef是$a,
     * 第二次是$a.b返回值
     * @private
     */
    getAttributes(property: Attribute, baseRef: unknown, ast: ReferencesAST): any;
    /**
     * $foo.bar[1] index求值
     * @private
     */
    getPropIndex(property: IndexAttribute, baseRef: object): any;
    /**
     * $foo.bar()求值
     */
    getPropMethod(property: Method, baseRef: any, ast: ReferencesAST): any;
    _throw(ast: ReferencesAST, property: Attribute, errorName?: string): void;
}
